"use strict";
var FreeStyle = require("free-style");
var afterAllSync = (new (function () {
    function class_1() {
        var _this = this;
        this.afterAllSync = function (cb) {
            if (_this.pending)
                clearTimeout(_this.pending);
            _this.pending = setTimeout(cb);
        };
    }
    return class_1;
}())).afterAllSync;
var freeStyle = FreeStyle.create();
var singletonStyle = typeof window === 'undefined' ? { innerHTML: '' } : document.createElement('style');
if (typeof document !== 'undefined')
    document.head.appendChild(singletonStyle);
var styleUpdated = function () { return afterAllSync(function () {
    singletonStyle.innerHTML = freeStyle.getStyles();
}); };
exports.getRawStyles = function () { return freeStyle.getStyles(); };
function style() {
    var objects = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        objects[_i - 0] = arguments[_i];
    }
    var object = extend.apply(void 0, objects);
    var className = freeStyle.registerStyle(object);
    styleUpdated();
    return className;
}
exports.style = style;
function keyframes(frames) {
    var animationName = freeStyle.registerKeyframes(frames);
    styleUpdated();
    return animationName;
}
exports.keyframes = keyframes;
function extend() {
    var objects = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        objects[_i - 0] = arguments[_i];
    }
    var result = {};
    for (var _a = 0, objects_1 = objects; _a < objects_1.length; _a++) {
        var object = objects_1[_a];
        for (var key in object) {
            if ((key.indexOf('&:') === 0 || key.indexOf('@media') === 0)
                && result[key]) {
                result[key] = extend(result[key], object);
            }
            else {
                result[key] = object[key];
            }
        }
    }
    return result;
}
exports.extend = extend;
